<!--我的模型 -->
<template>
  <div style="position: relative">
    <div class="topBox">
      <div class="title">我的模型</div>
      <div class="instructions">集中管理平台训练、压缩及预置的生成式大模型，支持对模型进行评估、压缩及部署。</div>
    </div>
    <div class="tableBox" :style="{ height: tableHeight }">

      <el-form ref="myDataSetPage" :model="myDataSetPage" label-width="75px" :size="defaultFormItemSize" label-position="right" @submit.native.prevent>
        <filter-box :item-width="350" @search="refresh()" @reset="onReset">
          <el-form-item label-width="0px">
            <el-button class="add" type="primary" icon="el-icon-plus" :size="defaultFormItemSize" @click="add()">创建模型</el-button>
          </el-form-item>
          <el-form-item label-width="0px">

          </el-form-item>
          <el-form-item label="模型名称" prop="formFilter.modelName" label-width="120px">
            <el-input class="filter-item" v-model="myDataSetPage.formFilter.modelName" :clearable="true" placeholder="模型名称" />
          </el-form-item>
        </filter-box>
      </el-form>
      <vxe-table border show-header-overflow show-overflow :row-config="{ isHover: true }" :data="myDataSetPage.tableData.impl.dataList" min-height="96">
        <vxe-column field="modelName" title="模型名称"></vxe-column>
        <vxe-column field="modelId" title="模型ID"></vxe-column>
        <vxe-column field="modelType" title="模型类型">
          <template slot-scope="scope">
            {{ModelType.getValue(scope.row.modelType)}}
          </template>
        </vxe-column>
        <vxe-column field="businessLabel" title="业务标签"></vxe-column>
        <vxe-column field="lastVersionSource" title="最新版本来源"></vxe-column>
        <vxe-column field="versionCount" title="版本数量"></vxe-column>
        <vxe-column field="updateTime" title="创建时间"></vxe-column>
        <vxe-column field="operation" title="操作">
          <template slot-scope="scope">

            <el-button type="text" :size="defaultFormItemSize" @click="particulars(scope.row)">详情</el-button>
            <el-button type="text" :size="defaultFormItemSize" @click="addVersion(scope.row)">新增版本</el-button>
            <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button>
          </template>
        </vxe-column>
      </vxe-table>
      <el-row slot="pagination" type="flex" justify="end" style="margin-top: 16px;width: 100%;">
        <el-pagination :total="myDataSetPage.tableData.impl.totalCount" :current-page="myDataSetPage.tableData.impl.currentPage" :page-size="myDataSetPage.tableData.impl.pageSize" :page-sizes="[10, 20, 50, 100]" layout="total, prev, pager, next, sizes" @current-change="myDataSetPage.tableData.impl.onCurrentPageChange" @size-change="myDataSetPage.tableData.impl.onPageSizeChange">
        </el-pagination>
      </el-row>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
/* eslint-disable-next-line */
import { DropdownWidget, TableWidget, UploadWidget, ChartWidget } from '@/utils/widget.js'
import { MyModel } from '@/api/gptController.js'
import editOrAdd from './dialog/editOrAdd'
import particulars from './particulars/index'
import addVersion from './particulars/versionList/dialog/editOrAdd'

export default {
  data() {
    return {
      myDataSetPage: {
        formFilter: {
          modelName: '',
          isBaseModel: 0
        },

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    }
  },

  components: {},

  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight() {
      return this.getMainContextHeight - 145 + 'px'
    }
  },

  methods: {
    getwidgetData(params) {
      if (params == null) params = {}
      params = {
        modelManageDtoFilter: {
          ...this.myDataSetPage.formFilter
        },
        ...params,
        // orderParam: [
        //   {
        //     asc: true,
        //     dateAggregateBy: '',
        //     fieldName: ''
        //   }
        // ],
        // pageParam: {
        //   pageNum: 0,
        //   pageSize: 0
        // },
        promptTemplateDtoFilter: { ...this.myDataSetPage.formFilter }
      }

      return new Promise((resolve, reject) => {
        MyModel.list(this, params)
          .then((res) => {
            resolve({
              dataList: res.data.dataList,
              totalCount: res.data.totalCount
            })
          })
          .catch((e) => {
            reject(e)
          })
      })
    },
    addVersion(row) {
      this.$dialog
        .show(
          '新增版本',
          addVersion,
          {
            area: ['100%', '100%']
          },
          { tableItem: row, versionIndex: row.modelVersionList.slice(-1)[0].modelVersion }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    add() {
      this.$dialog
        .show(
          '创建模型',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: false }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    edit(item) {
      this.$dialog
        .show(
          '修改模型',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: true, item: item }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    del(item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { modelId: item.modelId }
        MyModel.delete(this, params)
          .then((res) => {
            this.$message.success('删除成功')
            this.refresh()
          })
          .catch((e) => {
            console.log(e)
          })
      })
    },
    particulars(item) {
      this.$dialog
        .show(
          '详情',
          particulars,
          {
            area: ['100%', '100%']
          },
          { tableItem: item }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    refresh(reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1)
      } else {
        this.myDataSetPage.tableData.impl.refreshTable()
      }
    },
    onReset() {
      this.$refs.myDataSetPage.resetFields()
      this.refresh(true)
    },
    formInit() {
      this.refresh()
    }
  },

  mounted() {
    this.formInit()
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/style/element-variables.scss';
.topBox {
  background-color: white;
  width: 100%;
  height: 95px;
  margin-bottom: 16px;
  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
    padding: 20px 20px 10px 20px;
  }
}
.instructions {
  padding: 0px 20px 20px 20px;

  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }
  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }
  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }
  .img {
    height: 72px;
    width: 140px;
  }
}
.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
</style>
